import re
import time
import argparse

def cur_exp_init():
    cur_exp = {
                'Time': 'None',
                'seed': 'None',
                'V2T': {
                    'R1': 0.0,
                    'R5': 0.0,
                    'R10': 0.0,
                    'MdR': 1000.0,
                    'MnR': 1000.0,
                },
                'T2V': {
                    'R1': 0.0,
                    'R5': 0.0,
                    'R10': 0.0,
                    'MdR': 1000.0,
                    'MnR': 1000.0,
                }
            }
    return cur_exp


start_time = time.time()

parser = argparse.ArgumentParser()
parser.add_argument("--dataset", type=str, default="msvd", help="Dataset name. Default msvd.")
args = parser.parse_args()
print(args.dataset)


file_name = "ckpts/ckpt_" + args.dataset + "_retrieval_looseType/log.txt"


with open(file_name, 'r') as f:
    lines = f.readlines()
    start_pattern = re.compile(r'Effective parameters:')
    seed_p = re.compile(r'seed: (\d+)')
    metric_p = re.compile(r'R@1: (.*) - .*R@5: (.*) - .*R@10: (.*) - .*Median R: (.*) - .*Mean R: (.*)')
    time_p = re.compile(r'(\d+)-(\d+)-(\d+) (\d+):(\d+)')
    exp_ls = []

    cur_exp = cur_exp_init()

    for idx, line in enumerate(lines):
        if start_pattern.match(line):
            if not cur_exp['T2V']['R1'] == 0.0: exp_ls.append(cur_exp)
            cur_exp = cur_exp_init()
        if cur_exp['Time'] == 'None' and time_p.match(line):
            run_t = time_p.findall(line)[0]
            cur_exp['Time'] = f"{run_t[0]}-{run_t[1]}-{run_t[2]} {run_t[3]}:{run_t[4]}"
            

        if 'seed' in line:
            cur_exp['seed'] = seed_p.findall(line)[0]
        if 'T2V' in line:
            m = metric_p.findall(line)[0]
            cur_exp['T2V']['R1'] = max(cur_exp['T2V']['R1'], float(m[0]))
            cur_exp['T2V']['R5'] = max(cur_exp['T2V']['R5'], float(m[1]))
            cur_exp['T2V']['R10'] = max(cur_exp['T2V']['R10'], float(m[2]))
            cur_exp['T2V']['MdR'] = min(cur_exp['T2V']['MdR'], float(m[3]))
            cur_exp['T2V']['MnR'] = min(cur_exp['T2V']['MnR'], float(m[4]))
        if 'V2T' in line:
            m = metric_p.findall(line)[0]
            cur_exp['V2T']['R1'] = max(cur_exp['V2T']['R1'], float(m[0]))
            cur_exp['V2T']['R5'] = max(cur_exp['V2T']['R5'], float(m[1]))
            cur_exp['V2T']['R10'] = max(cur_exp['V2T']['R10'], float(m[2]))
            cur_exp['V2T']['MdR'] = min(cur_exp['V2T']['MdR'], float(m[3]))
            cur_exp['V2T']['MnR'] = min(cur_exp['V2T']['MnR'], float(m[4]))
    if not cur_exp['T2V']['R1'] == 0.0: exp_ls.append(cur_exp)

    for item in exp_ls:
        print(item)

end_time = time.time()
print("Parse Time:", end_time - start_time, "seconds.")